<?php

namespace common\behaviors;

use yii;
use yii\base\Behavior;
use yii\db\ActiveRecord;
use dosamigos\transliterator\TransliteratorHelper;
class Slug extends Behavior
{
    public $in_attribute = 'name';
    public $out_attribute = 'slug';
    public $translit = true;

    public function events()
    {
        return [
            ActiveRecord::EVENT_BEFORE_INSERT=> 'getSlug',
            ActiveRecord::EVENT_BEFORE_UPDATE=> 'getSlug'
        ];
    }

    public function getSlug( $event )
    {
        if(!empty($this->owner->{$this->in_attribute})){
            if ( empty( $this->owner->{$this->out_attribute} ) ) {
                $this->owner->{$this->out_attribute} = $this->generateSlug( $this->owner->{$this->in_attribute} );
            } else {
                $this->owner->{$this->out_attribute} = $this->generateSlug( $this->owner->{$this->out_attribute} );
            }
        }

    }

    private function generateSlug( $slug )
    {
        $slug = $this->slugify( $slug );
        if ( $this->checkUniqueSlug( $slug ) ) {
            return $slug;
        } else {
            for ( $suffix = 2; !$this->checkUniqueSlug( $new_slug = $slug . '-' . $suffix ); $suffix++ ) {}
            return $new_slug;
        }
    }

    private function slugify( $slug )
    {
        if ( $this->translit ) {
            return  yii\helpers\Inflector::slug( $this->translit( $slug ), '-', true );
        } else {
            return $this->slug( $slug, '-', true );
        }
    }

    private function slug( $string, $replacement = '-', $lowercase = true )
    {
        $string = preg_replace( '/[^\p{L}\p{Nd}]+/u', $replacement, $string );
        $string = trim( $string, $replacement );
        return $lowercase ? strtolower( $string ) : $string;
    }

    private function checkUniqueSlug( $slug )
    {
        $pk = $this->owner->primaryKey();
        $pk = $pk[0];

        $condition = $this->out_attribute . ' = :out_attribute';
        $params = [ ':out_attribute' => $slug ];
        if ( !$this->owner->isNewRecord ) {
            $condition .= ' and ' . $pk . ' != :pk';
            $params[':pk'] = $this->owner->{$pk};
        }

        return !$this->owner->find()
            ->where( $condition, $params )
            ->one();
    }


    static function translit ($string, $setting = 'all')
    {
        $letter = array (

            'а' => 'a',   'б' => 'b',   'в' => 'v',
            'г' => 'g',   'д' => 'd',   'е' => 'e',
            'ё' => 'e',   'ж' => 'zh',  'з' => 'z',
            'и' => 'i',   'й' => 'y',   'к' => 'k',
            'л' => 'l',   'м' => 'm',   'н' => 'n',
            'о' => 'o',   'п' => 'p',   'р' => 'r',
            'с' => 's',   'т' => 't',   'у' => 'u',
            'ф' => 'f',   'х' => 'h',   'ц' => 'c',
            'ч' => 'ch',  'ш' => 'sh',  'щ' => 'sch',
            'ь' => "",    'ы' => 'y',   'ъ' => "",
            'э' => 'e',   'ю' => 'yu',  'я' => 'ya',
            'ї' => 'yi',  'є' => 'ye',  'і' => 'ee',

            'А' => 'A',   'Б' => 'B',   'В' => 'V',
            'Г' => 'G',   'Д' => 'D',   'Е' => 'E',
            'Ё' => 'E',   'Ж' => 'Zh',  'З' => 'Z',
            'И' => 'I',   'Й' => 'Y',   'К' => 'K',
            'Л' => 'L',   'М' => 'M',   'Н' => 'N',
            'О' => 'O',   'П' => 'P',   'Р' => 'R',
            'С' => 'S',   'Т' => 'T',   'У' => 'U',
            'Ф' => 'F',   'Х' => 'H',   'Ц' => 'C',
            'Ч' => 'Ch',  'Ш' => 'Sh',  'Щ' => 'Sch',
            'Ь' => "",    'Ы' => 'Y',   'Ъ' => "",
            'Э' => 'E',   'Ю' => 'Yu',  'Я' => 'Ya',
            'Ї' => 'Yi',  'Є' => 'Ye',  'І' => 'Ee'
        );

        $symbol = array (
            ' ' => '-',   "'" => '',    '"' => '',
            '!' => '',    "@" => '',    '#' => '',
            '$' => '',    "%" => '',    '^' => '',
            ';' => '',    "*" => '',    '(' => '',
            ')' => '',    "+" => '',    '~' => '',
            '.' => '',    ',' => '-',    '?' => '',
            '…' => '',    '№' => 'N',   '°' => '',
            '`' => '',    '|' => '',    '&' => '-and-',
            '<' => '',    '>' => ''
        );

        if ($setting == 'all')
        {
            $converter = $letter + $symbol;
        }
        else if ($setting == 'letter')
        {
            $converter = $letter;
        }
        else if ($setting == 'symbol')
        {
            $converter = $symbol;
        }

        $url = strtr ($string, $converter);

        $url = str_replace ("---", '-', $url);
        $url = str_replace ("--", '-', $url);

        return $url;
    }

}